{
    "$graph": [
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "sentieon",
                "driver"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": "$(inputs.threads)"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "inputBinding": {
                        "position": 110
                    },
                    "id": "#bqsr.cwl/advanced_options"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 110,
                        "prefix": "--after"
                    },
                    "id": "#bqsr.cwl/after"
                },
                {
                    "type": "string",
                    "default": "QualCal",
                    "inputBinding": {
                        "position": 100,
                        "prefix": "--algo"
                    },
                    "id": "#bqsr.cwl/algo"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 110,
                        "prefix": "--before"
                    },
                    "id": "#bqsr.cwl/before"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ],
                            "inputBinding": {
                                "prefix": "-i"
                            }
                        }
                    ],
                    "inputBinding": {
                        "position": 10
                    },
                    "secondaryFiles": [
                        ".bai"
                    ],
                    "id": "#bqsr.cwl/input_bam"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "--interval",
                        "position": 10
                    },
                    "id": "#bqsr.cwl/interval"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ],
                            "inputBinding": {
                                "prefix": "-k"
                            }
                        }
                    ],
                    "inputBinding": {
                        "position": 110
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#bqsr.cwl/known_sites"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 110,
                        "prefix": "--merge"
                    },
                    "id": "#bqsr.cwl/merge"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 110,
                        "prefix": "--qcal"
                    },
                    "id": "#bqsr.cwl/other_qcal"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 150
                    },
                    "id": "#bqsr.cwl/output_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ]
                        }
                    ],
                    "inputBinding": {
                        "position": 180
                    },
                    "id": "#bqsr.cwl/part_output"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 110,
                        "prefix": "--plot"
                    },
                    "id": "#bqsr.cwl/plot"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ],
                            "inputBinding": {
                                "prefix": "-q"
                            }
                        }
                    ],
                    "inputBinding": {
                        "position": 10
                    },
                    "id": "#bqsr.cwl/qcal"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 10,
                        "prefix": "-r"
                    },
                    "secondaryFiles": [
                        ".fai"
                    ],
                    "id": "#bqsr.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--shard",
                        "position": 10
                    },
                    "id": "#bqsr.cwl/shard"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-t",
                        "position": 10
                    },
                    "id": "#bqsr.cwl/threads"
                }
            ],
            "stderr": "bqsr.log",
            "id": "#bqsr.cwl",
            "outputs": [
                {
                    "type": "File",
                    "id": "#bqsr.cwl/log",
                    "outputBinding": {
                        "glob": "bqsr.log"
                    }
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_file)"
                    },
                    "id": "#bqsr.cwl/output"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": "$(inputs.threads)"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#bwa-mem-sort.cwl/advanced_options"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "--bam_compression",
                        "position": 110
                    },
                    "id": "#bwa-mem-sort.cwl/bam_compression"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-K"
                    },
                    "id": "#bwa-mem-sort.cwl/chunk_size"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-M"
                    },
                    "id": "#bwa-mem-sort.cwl/mark_secondary"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "int"
                        }
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-I",
                        "itemSeparator": ","
                    },
                    "id": "#bwa-mem-sort.cwl/min_std_max_min"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-k"
                    },
                    "doc": "-k INT        minimum seed length [19]",
                    "id": "#bwa-mem-sort.cwl/minimum_seed_length"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 110,
                        "prefix": "-o"
                    },
                    "id": "#bwa-mem-sort.cwl/output_file"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-R"
                    },
                    "id": "#bwa-mem-sort.cwl/readgroup"
                },
                {
                    "type": {
                        "type": "array",
                        "items": [
                            "string",
                            "File"
                        ]
                    },
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#bwa-mem-sort.cwl/reads"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 2
                    },
                    "secondaryFiles": [
                        ".fai",
                        ".bwt",
                        ".sa",
                        ".ann",
                        ".amb",
                        ".pac"
                    ],
                    "id": "#bwa-mem-sort.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-r",
                        "position": 110
                    },
                    "secondaryFiles": [
                        ".fai"
                    ],
                    "id": "#bwa-mem-sort.cwl/sort_reference"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 110,
                        "prefix": "-t"
                    },
                    "id": "#bwa-mem-sort.cwl/sort_threads"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-t"
                    },
                    "doc": "-t INT        number of threads [1]",
                    "id": "#bwa-mem-sort.cwl/threads"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "bwa-mem.log"
                    },
                    "id": "#bwa-mem-sort.cwl/bwa_log"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_file)"
                    },
                    "secondaryFiles": [
                        ".bai"
                    ],
                    "id": "#bwa-mem-sort.cwl/output"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "util-sort.log"
                    },
                    "id": "#bwa-mem-sort.cwl/sort_log"
                }
            ],
            "arguments": [
                {
                    "valueFrom": "bwa",
                    "position": 0
                },
                {
                    "valueFrom": "mem",
                    "position": 0
                },
                {
                    "valueFrom": "2> bwa-mem.log",
                    "position": 90,
                    "shellQuote": false
                },
                {
                    "valueFrom": "|",
                    "position": 90,
                    "shellQuote": false
                },
                {
                    "valueFrom": "sentieon",
                    "position": 100
                },
                {
                    "valueFrom": "util",
                    "position": 100
                },
                {
                    "valueFrom": "sort",
                    "position": 100
                },
                {
                    "valueFrom": "--sam2bam",
                    "position": 110
                },
                {
                    "valueFrom": "-",
                    "position": 110
                },
                {
                    "valueFrom": "2> util-sort.log",
                    "position": 120,
                    "shellQuote": false
                }
            ],
            "id": "#bwa-mem-sort.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "sentieon",
                "driver"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": "$(inputs.threads)"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "inputBinding": {
                        "position": 110
                    },
                    "id": "#dedup.cwl/advanced_options"
                },
                {
                    "type": "string",
                    "default": "Dedup",
                    "inputBinding": {
                        "position": 100,
                        "prefix": "--algo"
                    },
                    "id": "#dedup.cwl/algo"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "--bam_compression",
                        "position": 110
                    },
                    "id": "#dedup.cwl/bam_compression"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ],
                            "inputBinding": {
                                "prefix": "--dup_read_name"
                            }
                        }
                    ],
                    "inputBinding": {
                        "position": 110
                    },
                    "id": "#dedup.cwl/dup_read_name"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ],
                            "inputBinding": {
                                "prefix": "-i"
                            }
                        }
                    ],
                    "inputBinding": {
                        "position": 10
                    },
                    "secondaryFiles": [
                        ".bai"
                    ],
                    "id": "#dedup.cwl/input_bam"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "--interval",
                        "position": 10
                    },
                    "id": "#dedup.cwl/interval"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "inputBinding": {
                        "prefix": "--merge",
                        "position": 110
                    },
                    "id": "#dedup.cwl/merge"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--metrics",
                        "position": 110
                    },
                    "id": "#dedup.cwl/metrics"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "--optical_dup_pix_dist",
                        "position": 110
                    },
                    "id": "#dedup.cwl/optical_dup_pix_dist"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "inputBinding": {
                        "prefix": "--output_dup_read_name",
                        "position": 110
                    },
                    "id": "#dedup.cwl/output_dup_read_name"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 150
                    },
                    "id": "#dedup.cwl/output_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ]
                        }
                    ],
                    "inputBinding": {
                        "position": 180
                    },
                    "id": "#dedup.cwl/part_metrics"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 10,
                        "prefix": "-r"
                    },
                    "secondaryFiles": [
                        ".fai"
                    ],
                    "id": "#dedup.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": true,
                    "inputBinding": {
                        "prefix": "--rmdup",
                        "position": 110
                    },
                    "id": "#dedup.cwl/rmdup"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ],
                            "inputBinding": {
                                "prefix": "--score_info"
                            }
                        }
                    ],
                    "inputBinding": {
                        "position": 110
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#dedup.cwl/score_info"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--shard",
                        "position": 10
                    },
                    "id": "#dedup.cwl/shard"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-t",
                        "position": 10
                    },
                    "id": "#dedup.cwl/threads"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--traverse_param",
                        "position": 10
                    },
                    "id": "#dedup.cwl/traverse_param"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#dedup.cwl/log",
                    "outputBinding": {
                        "glob": "dedup.log"
                    }
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.metrics)"
                    },
                    "id": "#dedup.cwl/metrics_output"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_file)"
                    },
                    "secondaryFiles": ".bai",
                    "id": "#dedup.cwl/output"
                }
            ],
            "stderr": "dedup.log",
            "id": "#dedup.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "sentieon",
                "driver"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": "$(inputs.threads)"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "inputBinding": {
                        "position": 110
                    },
                    "id": "#dedup_pre.cwl/advanced_options"
                },
                {
                    "type": "string",
                    "default": "LocusCollector",
                    "inputBinding": {
                        "position": 100,
                        "prefix": "--algo"
                    },
                    "id": "#dedup_pre.cwl/algo"
                },
                {
                    "type": "string",
                    "default": "score_info",
                    "inputBinding": {
                        "prefix": "--fun",
                        "position": 110
                    },
                    "id": "#dedup_pre.cwl/fun"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ],
                            "inputBinding": {
                                "prefix": "-i"
                            }
                        }
                    ],
                    "inputBinding": {
                        "position": 10
                    },
                    "secondaryFiles": [
                        ".bai"
                    ],
                    "id": "#dedup_pre.cwl/input_bam"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 150
                    },
                    "id": "#dedup_pre.cwl/output_file"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 10,
                        "prefix": "-r"
                    },
                    "secondaryFiles": [
                        ".fai"
                    ],
                    "id": "#dedup_pre.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--shard",
                        "position": 10
                    },
                    "id": "#dedup_pre.cwl/shard"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-t",
                        "position": 10
                    },
                    "id": "#dedup_pre.cwl/threads"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--traverse_param",
                        "position": 10
                    },
                    "id": "#dedup_pre.cwl/traverse_param"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#dedup_pre.cwl/log",
                    "outputBinding": {
                        "glob": "dedup_pre.log"
                    }
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_file)"
                    },
                    "secondaryFiles": ".tbi",
                    "id": "#dedup_pre.cwl/output"
                }
            ],
            "stderr": "dedup_pre.log",
            "id": "#dedup_pre.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "sentieon",
                "driver"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": "$(inputs.threads)"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "inputBinding": {
                        "position": 110
                    },
                    "id": "#hc.cwl/advanced_options"
                },
                {
                    "type": "string",
                    "default": "Haplotyper",
                    "inputBinding": {
                        "position": 100,
                        "prefix": "--algo"
                    },
                    "id": "#hc.cwl/algo"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "inputBinding": {
                        "prefix": "--annotation",
                        "position": 110
                    },
                    "id": "#hc.cwl/annotation"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "inputBinding": {
                        "prefix": "--call_conf",
                        "position": 110
                    },
                    "id": "#hc.cwl/call_conf"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-d",
                        "position": 110
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#hc.cwl/dbsnp"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "inputBinding": {
                        "prefix": "--emit_conf",
                        "position": 110
                    },
                    "id": "#hc.cwl/emit_conf"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--emit_mode",
                        "position": 110
                    },
                    "id": "#hc.cwl/emit_mode"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-d",
                        "position": 110
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#hc.cwl/given"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--gq_bands",
                        "position": 110
                    },
                    "id": "#hc.cwl/gq_bands"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ],
                            "inputBinding": {
                                "prefix": "-i"
                            }
                        }
                    ],
                    "inputBinding": {
                        "position": 10
                    },
                    "secondaryFiles": [
                        ".bai"
                    ],
                    "id": "#hc.cwl/input_bam"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "--interval",
                        "position": 10
                    },
                    "id": "#hc.cwl/interval"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "--merge",
                        "position": 110
                    },
                    "id": "#hc.cwl/merge"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "--min_base_qual",
                        "position": 110
                    },
                    "id": "#hc.cwl/min_base_qual"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 150
                    },
                    "id": "#hc.cwl/output_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ]
                        }
                    ],
                    "inputBinding": {
                        "position": 180
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#hc.cwl/part_output"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--pcr_indel_model",
                        "position": 110
                    },
                    "id": "#hc.cwl/pcr_indel_model"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "--phasing",
                        "position": 110
                    },
                    "id": "#hc.cwl/phasing"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "--ploidy",
                        "position": 110
                    },
                    "id": "#hc.cwl/ploidy"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "--prune_factor",
                        "position": 110
                    },
                    "id": "#hc.cwl/prune_factor"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ],
                            "inputBinding": {
                                "prefix": "-q"
                            }
                        }
                    ],
                    "inputBinding": {
                        "position": 10
                    },
                    "id": "#hc.cwl/qcal"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 10,
                        "prefix": "-r"
                    },
                    "secondaryFiles": [
                        ".fai"
                    ],
                    "id": "#hc.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--shard",
                        "position": 10
                    },
                    "id": "#hc.cwl/shard"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-t",
                        "position": 10
                    },
                    "id": "#hc.cwl/threads"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--traverse_param",
                        "position": 10
                    },
                    "id": "#hc.cwl/traverse_param"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "--trim_soft_clip",
                        "position": 110
                    },
                    "id": "#hc.cwl/trim_soft_clip"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#hc.cwl/log",
                    "outputBinding": {
                        "glob": "hc.log"
                    }
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_file)"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#hc.cwl/output"
                }
            ],
            "stderr": "hc.log",
            "id": "#hc.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "sentieon",
                "plot"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#plot.cwl/fun"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 50,
                        "separate": false,
                        "prefix": "gc="
                    },
                    "id": "#plot.cwl/gc"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 20
                    },
                    "id": "#plot.cwl/input"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 50,
                        "separate": false,
                        "prefix": "isize="
                    },
                    "id": "#plot.cwl/isize"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "inputBinding": {
                        "position": 50,
                        "separate": false,
                        "prefix": "min_fp_rate="
                    },
                    "id": "#plot.cwl/min_fp_rate"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 50,
                        "separate": false,
                        "prefix": "mq="
                    },
                    "id": "#plot.cwl/mq"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 10,
                        "prefix": "-o"
                    },
                    "id": "#plot.cwl/output_file"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "inputBinding": {
                        "position": 50,
                        "separate": false,
                        "prefix": "point_size="
                    },
                    "id": "#plot.cwl/point_size"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 50,
                        "separate": false,
                        "prefix": "qd="
                    },
                    "id": "#plot.cwl/qd"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "inputBinding": {
                        "position": 50,
                        "separate": false,
                        "prefix": "target_titv="
                    },
                    "id": "#plot.cwl/target_titv"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 50,
                        "separate": false,
                        "prefix": "tranches_file="
                    },
                    "id": "#plot.cwl/tranches_file"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#plot.cwl/log",
                    "outputBinding": {
                        "glob": "plot.log"
                    }
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_file)"
                    },
                    "id": "#plot.cwl/output"
                }
            ],
            "stderr": "plot.log",
            "id": "#plot.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "sentieon",
                "driver"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": "$(inputs.threads)"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "inputBinding": {
                        "position": 110
                    },
                    "id": "#realign.cwl/advanced_options"
                },
                {
                    "type": "string",
                    "default": "Realigner",
                    "inputBinding": {
                        "position": 100,
                        "prefix": "--algo"
                    },
                    "id": "#realign.cwl/algo"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ],
                            "inputBinding": {
                                "prefix": "-i"
                            }
                        }
                    ],
                    "inputBinding": {
                        "position": 10
                    },
                    "secondaryFiles": [
                        ".bai"
                    ],
                    "id": "#realign.cwl/input_bam"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 110,
                        "prefix": "--interval_list"
                    },
                    "id": "#realign.cwl/interval_list"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ],
                            "inputBinding": {
                                "prefix": "-k"
                            }
                        }
                    ],
                    "inputBinding": {
                        "position": 110
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#realign.cwl/known_sites"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 150
                    },
                    "id": "#realign.cwl/output_file"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 10,
                        "prefix": "-r"
                    },
                    "secondaryFiles": [
                        ".fai"
                    ],
                    "id": "#realign.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--shard",
                        "position": 10
                    },
                    "id": "#realign.cwl/shard"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-t",
                        "position": 10
                    },
                    "id": "#realign.cwl/threads"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--traverse_param",
                        "position": 10
                    },
                    "id": "#realign.cwl/traverse_param"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#realign.cwl/log",
                    "outputBinding": {
                        "glob": "realign.log"
                    }
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_file)"
                    },
                    "secondaryFiles": ".bai",
                    "id": "#realign.cwl/output"
                }
            ],
            "stderr": "realign.log",
            "id": "#realign.cwl"
        },
        {
            "class": "Workflow",
            "doc": "DNAseq pipeline from fastq to vcf for multiple samples",
            "requirements": [
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": "$(inputs.threads)"
                }
            ],
            "inputs": [
                {
                    "type": [
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ]
                        }
                    ],
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#main/bqsr_known_sites"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/chunk_size"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#main/dbsnp"
                },
                {
                    "type": [
                        {
                            "type": "array",
                            "items": [
                                {
                                    "type": "array",
                                    "items": [
                                        "string",
                                        "File"
                                    ]
                                }
                            ]
                        }
                    ],
                    "id": "#main/input_reads"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "id": "#main/interval"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#main/library"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#main/mark_secondary"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "ILLUMINA",
                    "id": "#main/platform"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#main/readgroup"
                },
                {
                    "type": [
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ]
                        }
                    ],
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#main/realign_known_sites"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        ".bwt",
                        ".sa",
                        ".ann",
                        ".amb",
                        ".pac"
                    ],
                    "id": "#main/reference"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#main/sample"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/threads"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/pipeline/bwa_output",
                    "id": "#main/bwa_output"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "outputSource": "#main/pipeline/dedup_metrics_output",
                    "id": "#main/dedup_metric_output"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/pipeline/dedup_output",
                    "id": "#main/dedup_output"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/pipeline/output",
                    "id": "#main/output"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/pipeline/qcal_output",
                    "id": "#main/qcal_output"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "outputSource": "#main/pipeline/qcal_plot_output",
                    "id": "#main/qcal_plot_output"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/pipeline/realign_output",
                    "id": "#main/realign_output"
                }
            ],
            "steps": [
                {
                    "in": [
                        {
                            "source": "#main/bqsr_known_sites",
                            "id": "#main/pipeline/bqsr_known_sites"
                        },
                        {
                            "valueFrom": "${ return \"sorted_\"+inputs.readgroup+\"_\"+inputs.sample+\".bam\"; }",
                            "id": "#main/pipeline/bwa_output_bam"
                        },
                        {
                            "source": "#main/chunk_size",
                            "id": "#main/pipeline/chunk_size"
                        },
                        {
                            "source": "#main/dbsnp",
                            "id": "#main/pipeline/dbsnp"
                        },
                        {
                            "valueFrom": "${ return \"dedup-metrics_\"+inputs.readgroup+\"_\"+inputs.sample+\".txt\"; }",
                            "id": "#main/pipeline/dedup_metrics_output_file"
                        },
                        {
                            "valueFrom": "${ return \"deduped_\"+inputs.readgroup+\"_\"+inputs.sample+\".bam\"; }",
                            "id": "#main/pipeline/dedup_output_bam"
                        },
                        {
                            "source": "#main/input_reads",
                            "id": "#main/pipeline/input_reads"
                        },
                        {
                            "source": "#main/library",
                            "id": "#main/pipeline/library"
                        },
                        {
                            "source": "#main/mark_secondary",
                            "id": "#main/pipeline/mark_secondary"
                        },
                        {
                            "valueFrom": "${ return \"output_\"+inputs.readgroup+\"_\"+inputs.sample+\".vcf.gz\"; }",
                            "id": "#main/pipeline/output_file"
                        },
                        {
                            "source": "#main/platform",
                            "id": "#main/pipeline/platform"
                        },
                        {
                            "valueFrom": "${ return \"recal_table_\"+inputs.readgroup+\"_\"+inputs.sample; }",
                            "id": "#main/pipeline/qcal_output_file"
                        },
                        {
                            "source": "#main/readgroup",
                            "id": "#main/pipeline/readgroup"
                        },
                        {
                            "source": "#main/realign_known_sites",
                            "id": "#main/pipeline/realign_known_sites"
                        },
                        {
                            "valueFrom": "${ return \"realigned_\"+inputs.readgroup+\"_\"+inputs.sample+\".bam\"; }",
                            "id": "#main/pipeline/realign_output_bam"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/pipeline/reference"
                        },
                        {
                            "source": "#main/sample",
                            "id": "#main/pipeline/sample"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/pipeline/threads"
                        }
                    ],
                    "out": [
                        "#main/pipeline/bwa_output",
                        "#main/pipeline/dedup_output",
                        "#main/pipeline/dedup_metrics_output",
                        "#main/pipeline/realign_output",
                        "#main/pipeline/qcal_output",
                        "#main/pipeline/qcal_plot_output",
                        "#main/pipeline/output"
                    ],
                    "scatter": [
                        "#main/pipeline/readgroup",
                        "#main/pipeline/sample",
                        "#main/pipeline/library",
                        "#main/pipeline/input_reads"
                    ],
                    "scatterMethod": "dotproduct",
                    "run": "#pipeline-fastq2vcf.cwl",
                    "id": "#main/pipeline"
                }
            ],
            "id": "#main"
        },
        {
            "class": "Workflow",
            "doc": "DNAseq pipeline from fastq to vcf",
            "requirements": [
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": "$(inputs.threads)"
                }
            ],
            "inputs": [
                {
                    "type": [
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ]
                        }
                    ],
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#pipeline-fastq2vcf.cwl/bqsr_known_sites"
                },
                {
                    "type": "string",
                    "id": "#pipeline-fastq2vcf.cwl/bwa_output_bam"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#pipeline-fastq2vcf.cwl/chunk_size"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#pipeline-fastq2vcf.cwl/dbsnp"
                },
                {
                    "type": "string",
                    "id": "#pipeline-fastq2vcf.cwl/dedup_metrics_output_file"
                },
                {
                    "type": "string",
                    "id": "#pipeline-fastq2vcf.cwl/dedup_output_bam"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#pipeline-fastq2vcf.cwl/emit_mode"
                },
                {
                    "type": {
                        "type": "array",
                        "items": [
                            "string",
                            "File"
                        ]
                    },
                    "id": "#pipeline-fastq2vcf.cwl/input_reads"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "id": "#pipeline-fastq2vcf.cwl/interval"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "library",
                    "id": "#pipeline-fastq2vcf.cwl/library"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#pipeline-fastq2vcf.cwl/mark_secondary"
                },
                {
                    "type": "string",
                    "id": "#pipeline-fastq2vcf.cwl/output_file"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "ILLUMINA",
                    "id": "#pipeline-fastq2vcf.cwl/platform"
                },
                {
                    "type": "string",
                    "id": "#pipeline-fastq2vcf.cwl/qcal_output_file"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#pipeline-fastq2vcf.cwl/qcal_plot_output_csv_file"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#pipeline-fastq2vcf.cwl/qcal_plot_output_file"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#pipeline-fastq2vcf.cwl/readgroup"
                },
                {
                    "type": [
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ]
                        }
                    ],
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#pipeline-fastq2vcf.cwl/realign_known_sites"
                },
                {
                    "type": "string",
                    "id": "#pipeline-fastq2vcf.cwl/realign_output_bam"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        ".bwt",
                        ".sa",
                        ".ann",
                        ".amb",
                        ".pac"
                    ],
                    "id": "#pipeline-fastq2vcf.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#pipeline-fastq2vcf.cwl/sample"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#pipeline-fastq2vcf.cwl/threads"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#pipeline-fastq2vcf.cwl/bwa/output",
                    "id": "#pipeline-fastq2vcf.cwl/bwa_output"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#pipeline-fastq2vcf.cwl/dedup/metrics_output",
                    "id": "#pipeline-fastq2vcf.cwl/dedup_metrics_output"
                },
                {
                    "type": "File",
                    "outputSource": "#pipeline-fastq2vcf.cwl/dedup/output",
                    "id": "#pipeline-fastq2vcf.cwl/dedup_output"
                },
                {
                    "type": "File",
                    "outputSource": "#pipeline-fastq2vcf.cwl/hc/output",
                    "id": "#pipeline-fastq2vcf.cwl/output"
                },
                {
                    "type": "File",
                    "outputSource": "#pipeline-fastq2vcf.cwl/bqsr/qcal_output",
                    "id": "#pipeline-fastq2vcf.cwl/qcal_output"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#pipeline-fastq2vcf.cwl/bqsr/plot_csv_output",
                    "id": "#pipeline-fastq2vcf.cwl/qcal_plot_csv_output"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#pipeline-fastq2vcf.cwl/bqsr/plot_output",
                    "id": "#pipeline-fastq2vcf.cwl/qcal_plot_output"
                },
                {
                    "type": "File",
                    "outputSource": "#pipeline-fastq2vcf.cwl/realign/output",
                    "id": "#pipeline-fastq2vcf.cwl/realign_output"
                }
            ],
            "steps": [
                {
                    "in": [
                        {
                            "source": "#pipeline-fastq2vcf.cwl/realign/output",
                            "valueFrom": "${ return [ self ]; }",
                            "id": "#pipeline-fastq2vcf.cwl/bqsr/input_bam"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/interval",
                            "id": "#pipeline-fastq2vcf.cwl/bqsr/interval"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/bqsr_known_sites",
                            "id": "#pipeline-fastq2vcf.cwl/bqsr/known_sites"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/qcal_output_file",
                            "id": "#pipeline-fastq2vcf.cwl/bqsr/output_file"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/qcal_output_file",
                            "valueFrom": "${ return self + \".csv\"; }",
                            "id": "#pipeline-fastq2vcf.cwl/bqsr/plot_output_csv_file"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/qcal_output_file",
                            "valueFrom": "${ return self + \".pdf\"; }",
                            "id": "#pipeline-fastq2vcf.cwl/bqsr/plot_output_file"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/reference",
                            "id": "#pipeline-fastq2vcf.cwl/bqsr/reference"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/threads",
                            "id": "#pipeline-fastq2vcf.cwl/bqsr/threads"
                        }
                    ],
                    "out": [
                        "#pipeline-fastq2vcf.cwl/bqsr/qcal_output",
                        "#pipeline-fastq2vcf.cwl/bqsr/plot_output",
                        "#pipeline-fastq2vcf.cwl/bqsr/plot_csv_output"
                    ],
                    "run": "#bqsr-flow.cwl",
                    "id": "#pipeline-fastq2vcf.cwl/bqsr"
                },
                {
                    "in": [
                        {
                            "source": "#pipeline-fastq2vcf.cwl/library",
                            "id": "#pipeline-fastq2vcf.cwl/bwa/_library"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/platform",
                            "id": "#pipeline-fastq2vcf.cwl/bwa/_platform"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/readgroup",
                            "id": "#pipeline-fastq2vcf.cwl/bwa/_readgroup"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/sample",
                            "id": "#pipeline-fastq2vcf.cwl/bwa/_sample"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/chunk_size",
                            "id": "#pipeline-fastq2vcf.cwl/bwa/chunk_size"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/mark_secondary",
                            "id": "#pipeline-fastq2vcf.cwl/bwa/mark_secondary"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/bwa_output_bam",
                            "id": "#pipeline-fastq2vcf.cwl/bwa/output_file"
                        },
                        {
                            "valueFrom": "${\n  var rg = \"@RG\\tID:\" + inputs._readgroup + \"\\tSM:\" + inputs._sample\n           + \"\\tPL:\" + inputs._platform;\n  if ( inputs._library != null ) rg += \"\\tLB:\" + inputs._library;\n  return rg;\n}\n",
                            "id": "#pipeline-fastq2vcf.cwl/bwa/readgroup"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/input_reads",
                            "id": "#pipeline-fastq2vcf.cwl/bwa/reads"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/reference",
                            "id": "#pipeline-fastq2vcf.cwl/bwa/reference"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/threads",
                            "id": "#pipeline-fastq2vcf.cwl/bwa/sort_threads"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/threads",
                            "id": "#pipeline-fastq2vcf.cwl/bwa/threads"
                        }
                    ],
                    "out": [
                        "#pipeline-fastq2vcf.cwl/bwa/output"
                    ],
                    "run": "#bwa-mem-sort.cwl",
                    "id": "#pipeline-fastq2vcf.cwl/bwa"
                },
                {
                    "in": [
                        {
                            "source": "#pipeline-fastq2vcf.cwl/bwa/output",
                            "valueFrom": "${ return [ self ]; }",
                            "id": "#pipeline-fastq2vcf.cwl/dedup/input_bam"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/interval",
                            "id": "#pipeline-fastq2vcf.cwl/dedup/interval"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/dedup_metrics_output_file",
                            "id": "#pipeline-fastq2vcf.cwl/dedup/metrics_output_file"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/dedup_output_bam",
                            "id": "#pipeline-fastq2vcf.cwl/dedup/output_file"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/reference",
                            "id": "#pipeline-fastq2vcf.cwl/dedup/reference"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/threads",
                            "id": "#pipeline-fastq2vcf.cwl/dedup/threads"
                        }
                    ],
                    "out": [
                        "#pipeline-fastq2vcf.cwl/dedup/output",
                        "#pipeline-fastq2vcf.cwl/dedup/metrics_output"
                    ],
                    "run": "#dedup-2-pass.cwl",
                    "id": "#pipeline-fastq2vcf.cwl/dedup"
                },
                {
                    "in": [
                        {
                            "source": "#pipeline-fastq2vcf.cwl/dbsnp",
                            "id": "#pipeline-fastq2vcf.cwl/hc/dbsnp"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/emit_mode",
                            "id": "#pipeline-fastq2vcf.cwl/hc/emit_mode"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/realign/output",
                            "valueFrom": "${ return [ self ]; }",
                            "id": "#pipeline-fastq2vcf.cwl/hc/input_bam"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/interval",
                            "id": "#pipeline-fastq2vcf.cwl/hc/interval"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/output_file",
                            "id": "#pipeline-fastq2vcf.cwl/hc/output_file"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/bqsr/qcal_output",
                            "valueFrom": "${ return [ self ]; }",
                            "id": "#pipeline-fastq2vcf.cwl/hc/qcal"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/reference",
                            "id": "#pipeline-fastq2vcf.cwl/hc/reference"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/threads",
                            "id": "#pipeline-fastq2vcf.cwl/hc/threads"
                        }
                    ],
                    "out": [
                        "#pipeline-fastq2vcf.cwl/hc/output"
                    ],
                    "run": "#hc.cwl",
                    "id": "#pipeline-fastq2vcf.cwl/hc"
                },
                {
                    "in": [
                        {
                            "source": "#pipeline-fastq2vcf.cwl/dedup/output",
                            "valueFrom": "${ return [ self ]; }",
                            "id": "#pipeline-fastq2vcf.cwl/realign/input_bam"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/interval",
                            "id": "#pipeline-fastq2vcf.cwl/realign/interval_list"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/realign_known_sites",
                            "id": "#pipeline-fastq2vcf.cwl/realign/known_sites"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/realign_output_bam",
                            "id": "#pipeline-fastq2vcf.cwl/realign/output_file"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/reference",
                            "id": "#pipeline-fastq2vcf.cwl/realign/reference"
                        },
                        {
                            "source": "#pipeline-fastq2vcf.cwl/threads",
                            "id": "#pipeline-fastq2vcf.cwl/realign/threads"
                        }
                    ],
                    "out": [
                        "#pipeline-fastq2vcf.cwl/realign/output"
                    ],
                    "run": "#realign.cwl",
                    "id": "#pipeline-fastq2vcf.cwl/realign"
                }
            ],
            "id": "#pipeline-fastq2vcf.cwl"
        },
        {
            "class": "Workflow",
            "doc": "Run BQSR pre+post+plot flow",
            "requirements": [
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": "$(inputs.threads)"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#bqsr-flow.cwl/advanced_options/bqsr",
                                    "type": [
                                        "null",
                                        {
                                            "type": "array",
                                            "items": "string"
                                        }
                                    ]
                                },
                                {
                                    "name": "#bqsr-flow.cwl/advanced_options/bqsr_post",
                                    "type": [
                                        "null",
                                        {
                                            "type": "array",
                                            "items": "string"
                                        }
                                    ]
                                }
                            ]
                        }
                    ],
                    "id": "#bqsr-flow.cwl/advanced_options"
                },
                {
                    "type": [
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ]
                        }
                    ],
                    "secondaryFiles": [
                        ".bai"
                    ],
                    "id": "#bqsr-flow.cwl/input_bam"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "id": "#bqsr-flow.cwl/interval"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ]
                        }
                    ],
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#bqsr-flow.cwl/known_sites"
                },
                {
                    "type": "string",
                    "id": "#bqsr-flow.cwl/output_file"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#bqsr-flow.cwl/plot_output_csv_file"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#bqsr-flow.cwl/plot_output_file"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai"
                    ],
                    "id": "#bqsr-flow.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#bqsr-flow.cwl/threads"
                }
            ],
            "outputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#bqsr-flow.cwl/bqsr_plot/output",
                    "id": "#bqsr-flow.cwl/plot_csv_output"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#bqsr-flow.cwl/plot/output",
                    "id": "#bqsr-flow.cwl/plot_output"
                },
                {
                    "type": "File",
                    "outputSource": "#bqsr-flow.cwl/bqsr/output",
                    "id": "#bqsr-flow.cwl/qcal_output"
                }
            ],
            "steps": [
                {
                    "in": [
                        {
                            "source": "#bqsr-flow.cwl/advanced_options",
                            "valueFrom": "${ return self ? self.bqsr : []; }\n",
                            "id": "#bqsr-flow.cwl/bqsr/advanced_options"
                        },
                        {
                            "source": "#bqsr-flow.cwl/input_bam",
                            "id": "#bqsr-flow.cwl/bqsr/input_bam"
                        },
                        {
                            "source": "#bqsr-flow.cwl/interval",
                            "id": "#bqsr-flow.cwl/bqsr/interval"
                        },
                        {
                            "source": "#bqsr-flow.cwl/known_sites",
                            "id": "#bqsr-flow.cwl/bqsr/known_sites"
                        },
                        {
                            "source": "#bqsr-flow.cwl/output_file",
                            "id": "#bqsr-flow.cwl/bqsr/output_file"
                        },
                        {
                            "source": "#bqsr-flow.cwl/reference",
                            "id": "#bqsr-flow.cwl/bqsr/reference"
                        },
                        {
                            "source": "#bqsr-flow.cwl/threads",
                            "id": "#bqsr-flow.cwl/bqsr/threads"
                        }
                    ],
                    "out": [
                        "#bqsr-flow.cwl/bqsr/output"
                    ],
                    "run": "#bqsr.cwl",
                    "id": "#bqsr-flow.cwl/bqsr"
                },
                {
                    "in": [
                        {
                            "source": "#bqsr-flow.cwl/bqsr_post/output",
                            "id": "#bqsr-flow.cwl/bqsr_plot/after"
                        },
                        {
                            "source": "#bqsr-flow.cwl/bqsr/output",
                            "id": "#bqsr-flow.cwl/bqsr_plot/before"
                        },
                        {
                            "source": [
                                "#bqsr-flow.cwl/output_file",
                                "#bqsr-flow.cwl/plot_output_csv_file"
                            ],
                            "valueFrom": "${\n  if(self[1] != null)\n      return self[1];\n  else\n      return self[0] + \".csv\";\n}    \n",
                            "id": "#bqsr-flow.cwl/bqsr_plot/output_file"
                        },
                        {
                            "valueFrom": "${ return true; }",
                            "id": "#bqsr-flow.cwl/bqsr_plot/plot"
                        },
                        {
                            "source": "#bqsr-flow.cwl/threads",
                            "id": "#bqsr-flow.cwl/bqsr_plot/threads"
                        }
                    ],
                    "out": [
                        "#bqsr-flow.cwl/bqsr_plot/output"
                    ],
                    "run": "#bqsr.cwl",
                    "id": "#bqsr-flow.cwl/bqsr_plot"
                },
                {
                    "in": [
                        {
                            "source": "#bqsr-flow.cwl/advanced_options",
                            "valueFrom": "${ return self ? self.bqsr_post : []; }\n",
                            "id": "#bqsr-flow.cwl/bqsr_post/advanced_options"
                        },
                        {
                            "source": "#bqsr-flow.cwl/input_bam",
                            "id": "#bqsr-flow.cwl/bqsr_post/input_bam"
                        },
                        {
                            "source": "#bqsr-flow.cwl/interval",
                            "id": "#bqsr-flow.cwl/bqsr_post/interval"
                        },
                        {
                            "source": "#bqsr-flow.cwl/output_file",
                            "valueFrom": "$(self).post",
                            "id": "#bqsr-flow.cwl/bqsr_post/output_file"
                        },
                        {
                            "source": "#bqsr-flow.cwl/bqsr/output",
                            "valueFrom": "${ return [ self ]; }",
                            "id": "#bqsr-flow.cwl/bqsr_post/qcal"
                        },
                        {
                            "source": "#bqsr-flow.cwl/reference",
                            "id": "#bqsr-flow.cwl/bqsr_post/reference"
                        },
                        {
                            "source": "#bqsr-flow.cwl/threads",
                            "id": "#bqsr-flow.cwl/bqsr_post/threads"
                        }
                    ],
                    "out": [
                        "#bqsr-flow.cwl/bqsr_post/output"
                    ],
                    "run": "#bqsr.cwl",
                    "id": "#bqsr-flow.cwl/bqsr_post"
                },
                {
                    "in": [
                        {
                            "valueFrom": "${ return \"bqsr\"; }",
                            "id": "#bqsr-flow.cwl/plot/fun"
                        },
                        {
                            "source": "#bqsr-flow.cwl/bqsr_plot/output",
                            "id": "#bqsr-flow.cwl/plot/input"
                        },
                        {
                            "source": [
                                "#bqsr-flow.cwl/output_file",
                                "#bqsr-flow.cwl/plot_output_file"
                            ],
                            "valueFrom": "${\n  if(self[1] != null)\n      return self[1];\n  else\n      return self[0] + \".pdf\";\n} \n",
                            "id": "#bqsr-flow.cwl/plot/output_file"
                        }
                    ],
                    "out": [
                        "#bqsr-flow.cwl/plot/output"
                    ],
                    "run": "#plot.cwl",
                    "id": "#bqsr-flow.cwl/plot"
                }
            ],
            "id": "#bqsr-flow.cwl"
        },
        {
            "class": "Workflow",
            "doc": "run 2-pass dedup: algo LocusCollector + algo Dedup sequentially",
            "requirements": [
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": "$(inputs.threads)"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#dedup-2-pass.cwl/advanced_options/dedup_pre",
                                    "type": [
                                        "null",
                                        {
                                            "type": "array",
                                            "items": "string"
                                        }
                                    ]
                                },
                                {
                                    "name": "#dedup-2-pass.cwl/advanced_options/dedup",
                                    "type": [
                                        "null",
                                        {
                                            "type": "array",
                                            "items": "string"
                                        }
                                    ]
                                }
                            ]
                        }
                    ],
                    "id": "#dedup-2-pass.cwl/advanced_options"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#dedup-2-pass.cwl/bam_compression"
                },
                {
                    "type": [
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ]
                        }
                    ],
                    "secondaryFiles": [
                        ".bai"
                    ],
                    "id": "#dedup-2-pass.cwl/input_bam"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "id": "#dedup-2-pass.cwl/interval"
                },
                {
                    "type": "string",
                    "id": "#dedup-2-pass.cwl/metrics_output_file"
                },
                {
                    "type": "string",
                    "id": "#dedup-2-pass.cwl/output_file"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai"
                    ],
                    "id": "#dedup-2-pass.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#dedup-2-pass.cwl/threads"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#dedup-2-pass.cwl/traverse_param"
                }
            ],
            "outputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#dedup-2-pass.cwl/dedup/metrics_output",
                    "id": "#dedup-2-pass.cwl/metrics_output"
                },
                {
                    "type": "File",
                    "outputSource": "#dedup-2-pass.cwl/dedup/output",
                    "id": "#dedup-2-pass.cwl/output"
                }
            ],
            "steps": [
                {
                    "in": [
                        {
                            "source": "#dedup-2-pass.cwl/advanced_options",
                            "valueFrom": "${ return self ? self.dedup : []; }\n",
                            "id": "#dedup-2-pass.cwl/dedup/advanced_options"
                        },
                        {
                            "source": "#dedup-2-pass.cwl/bam_compression",
                            "id": "#dedup-2-pass.cwl/dedup/bam_compression"
                        },
                        {
                            "source": "#dedup-2-pass.cwl/input_bam",
                            "id": "#dedup-2-pass.cwl/dedup/input_bam"
                        },
                        {
                            "source": "#dedup-2-pass.cwl/interval",
                            "id": "#dedup-2-pass.cwl/dedup/interval"
                        },
                        {
                            "source": "#dedup-2-pass.cwl/metrics_output_file",
                            "id": "#dedup-2-pass.cwl/dedup/metrics"
                        },
                        {
                            "source": "#dedup-2-pass.cwl/output_file",
                            "id": "#dedup-2-pass.cwl/dedup/output_file"
                        },
                        {
                            "source": "#dedup-2-pass.cwl/reference",
                            "id": "#dedup-2-pass.cwl/dedup/reference"
                        },
                        {
                            "source": "#dedup-2-pass.cwl/dedup_pre/output",
                            "valueFrom": "${ return [ self ]; }",
                            "id": "#dedup-2-pass.cwl/dedup/score_info"
                        },
                        {
                            "source": "#dedup-2-pass.cwl/threads",
                            "id": "#dedup-2-pass.cwl/dedup/threads"
                        },
                        {
                            "source": "#dedup-2-pass.cwl/traverse_param",
                            "id": "#dedup-2-pass.cwl/dedup/traverse_param"
                        }
                    ],
                    "out": [
                        "#dedup-2-pass.cwl/dedup/output",
                        "#dedup-2-pass.cwl/dedup/metrics_output"
                    ],
                    "run": "#dedup.cwl",
                    "id": "#dedup-2-pass.cwl/dedup"
                },
                {
                    "in": [
                        {
                            "source": "#dedup-2-pass.cwl/advanced_options",
                            "valueFrom": "${ return self ? self.dedup_pre : []; }\n",
                            "id": "#dedup-2-pass.cwl/dedup_pre/advanced_options"
                        },
                        {
                            "source": "#dedup-2-pass.cwl/input_bam",
                            "id": "#dedup-2-pass.cwl/dedup_pre/input_bam"
                        },
                        {
                            "source": "#dedup-2-pass.cwl/output_file",
                            "valueFrom": "$(self).score.gz",
                            "id": "#dedup-2-pass.cwl/dedup_pre/output_file"
                        },
                        {
                            "source": "#dedup-2-pass.cwl/reference",
                            "id": "#dedup-2-pass.cwl/dedup_pre/reference"
                        },
                        {
                            "source": "#dedup-2-pass.cwl/threads",
                            "id": "#dedup-2-pass.cwl/dedup_pre/threads"
                        },
                        {
                            "source": "#dedup-2-pass.cwl/traverse_param",
                            "id": "#dedup-2-pass.cwl/dedup_pre/traverse_param"
                        }
                    ],
                    "out": [
                        "#dedup-2-pass.cwl/dedup_pre/output"
                    ],
                    "run": "#dedup_pre.cwl",
                    "id": "#dedup-2-pass.cwl/dedup_pre"
                }
            ],
            "id": "#dedup-2-pass.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
